rem Clock for 80535 timers
rem Copyright 1993-1997 by Dr. O'Niel Annand Valentin Som

asm $include register.asm
ONTIM2 goto intr_handler
         register rcap2l $CA
         register rcap2h $CB
         register tl2 $CC
         register th2 $CD
         register t2con $C8
         register ie $A8
         print "Please enter actual time"
         input "hours:   " std
         input "minutes: " min
         sec = 0
         ms_50 = 0
         rcap2l = 175 : rem values for 12 MHz
         rcap2h = 60 : th2 = 0
         tl2 = 0 : ie = $A0
         t2con = $11
         repeat : until 1 <> 1 : rem wait for interrupt
         end
intr_handler:
         asm saveregs
         inc ms_50
         if ms_50 >= 20
           then ms_50 = 0
           else : endif
         reset $C6 : rem reset timer 2 overflow flag
         if ms_50 = 0
         then
           inc sec
           if sec >= 60
           then
             sec = 0
             inc min
             if min >= 60
             then
               min = 0
               inc std
               if std >= 24
                 then std = 0
                 else : endif
             else : endif
           else : endif
         print std ":" min "." sec
         else : endif
         asm restoreregs
         ireturn
